# MultiTypograf [![Build Status](https://secure.travis-ci.org/stereobooster/multi_typograf.png?branch=master)](https://secure.travis-ci.org/#!/stereobooster/multi_typograf) [![Dependency Status](https://gemnasium.com/stereobooster/multi_typograf.png?travis)](https://gemnasium.com/stereobooster/multi_typograf) [![Code Climate](https://codeclimate.com/badge.png)](https://codeclimate.com/github/stereobooster/multi_typograf)

There are lot of Ruby libraries for typographing text.
Instead of choosing a single implementation and forcing users of your library to be
stuck with it, you can use MultiTypograf instead, which will simply choose the
best available tipographer. Here's how to use it:

```ruby
require 'multi_typograf'

MultiTypograf.process('тест') #=> 'тест'
```

The `use` method, which sets the MultiTypograf adapter, takes either a symbol or a
class (to allow for custom CSS minifier) that responds to `.process` at the class level.

MultiTypograf tries to have intelligent defaulting. That is, if you have any of the
supported engines already loaded, it will utilize them before attempting to
load any. 
It will load libraries in following order:

 - [art_typograf](https://github.com/stereobooster/art_typograf) wrapper for http://www.artlebedev.ru/tools/typograf/
 - TODO [typographer](https://github.com/brain-geek/typographer)
 - TODO [typographica](https://github.com/akolosov/typographica)

If no other library is available, MultiTypograf falls back to [typograf](https://github.com/stereobooster/typograf) wrapper for http://www.typograf.ru/.

## HTML::Pipeline

```ruby
pipeline = HTML::Pipeline.new [
  MultiTypograf::Filter
]
pipeline.call('тест') #=> 'тест'
```

## TODO

 - map options
 - [HtmlPipeline](https://github.com/jch/html-pipeline) filter
 - [Rails plugin](http://guides.rubyonrails.org/plugins.html)

## Contributing

1. Fork it
2. Create your feature branch (`git checkout -b my-new-feature`)
3. Commit your changes (`git commit -am 'Add some feature'`)
4. Push to the branch (`git push origin my-new-feature`)
5. Create new Pull Request
