# encoding: utf-8

shared_examples_for "an adapter" do |adapter|

  before do
    begin
      MultiTypograf.use adapter
    rescue LoadError
      pending "Adapter #{adapter} couldn't be loaded (not installed?)"
    end
  end

  OPT = {
    :use_p => false, :use_br => false, :entity_type => :html,
    :nowraped => {:nonbsp => 0}, :paragraph => {:insert => 0}, :symbols => 0
  } unless defined? OPT

  describe '.process' do

    it 'It works' do
      text = "В этом тексте много пробелов."
      text_processed = 'В&nbsp;этом тексте много пробелов.'
      MultiTypograf.process(text, OPT).should eq text_processed
    end

  end
end
